package com.cnbm.admin.enums;

/**
 * <p>
 * 是、否有效枚举
 * </P>
 *
 * @author xcc
 * @date 2022年7月5日
 * @since 1.0
 */
public enum WhetherEnum {

    NO(0, "否"),

    YES(1, "是");

    private final Integer value;
    private final String label;
    private final String remark;

    WhetherEnum(final int value, final String label) {
        this(value, label, null);
    }

    WhetherEnum(final int value, final String label, final String remark) {
        this.value = value;
        this.label = label;
        this.remark = remark;
    }

    /**
     * @return 数据值
     */
    public Integer getValue() {
        return value;
    }

    /**
     * @return 标签名
     */
    public String getLabel() {
        return label;
    }

    /**
     * @return 备注
     */
    public String getRemark() {
        return remark;
    }
}
