package com.cnbm.generator.code.entity;

import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDateTime;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * <p>
 * 包装箱表
 * </p>
 *
 * @author codeGenerator
 * @since 2023-02-23
 */
@Data
@TableName("t_wo_packaging_box")
@ApiModel(value = "WoPackagingBox对象", description = "包装箱表")
public class WoPackagingBox implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("ID")
    private Long id;

    @ApiModelProperty("订单ID(舍弃)")
    private Long orderId;

    @ApiModelProperty("工单ID（舍弃啊）")
    private Long workOrderId;

    @ApiModelProperty("包装箱编号，这个就是boxId,关联 t_wo_packaging_box表的 boxId")
    private String boxNo;

    @ApiModelProperty("功率，单位瓦（舍弃）")
    private Integer power;

    @ApiModelProperty("等级（舍弃）")
    private Integer grade;

    @ApiModelProperty("基板数量，每个包装箱最大20片（舍弃）")
    private Integer substrateQuantity;

    @ApiModelProperty("装箱完成时间，指的是包装完成时间")
    private LocalDateTime packagingTime;

    @ApiModelProperty("打印时间（最近一次打印时间）")
    private LocalDateTime printTime;

    @ApiModelProperty("打印状态：0、未打印，1、已打印")
    private Integer printStatus;

    @ApiModelProperty("报工状态：0、未报工，1、已报工(舍弃)")
    private Integer completionReportingStatus;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("删除标志，是否有效:1 可用 0不可用")
    @TableLogic
    private Integer valid;

    @ApiModelProperty("创建人")
    private Long creatorId;

    @ApiModelProperty("创建人姓名")
    private String creatorName;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private Long updaterId;

    @ApiModelProperty("更新人姓名")
    private String updaterName;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty("版本号")
    private Integer version;

    @ApiModelProperty("离开产线时间（舍弃）")
    private LocalDateTime leaveLineTime;

    @ApiModelProperty("下片端口id（舍弃）")
    private String portId;

    @ApiModelProperty("打印次数")
    private Integer printCount;

    @ApiModelProperty("功率等级")
    private String powerLevel;

    @ApiModelProperty("客户id（舍弃）")
    private Long customerId;

    @ApiModelProperty("SAP MATERIAL,从t_wo_power_level 对应过来的")
    private String sapMaterial;

    @ApiModelProperty("线体,从t_wo_power_level 对应过来的，1=F ; 2=S")
    private Integer lineBody;

    @ApiModelProperty("模式，1-手动模式；2-自动模式")
    private Integer model;

    @ApiModelProperty("是否到达包装台，1=到达；2=未达到")
    private Integer isArrived;

    @ApiModelProperty("订单号")
    private String orderNum;


    public static final String ID = "ID";

    public static final String ORDER_ID = "ORDER_ID";

    public static final String WORK_ORDER_ID = "WORK_ORDER_ID";

    public static final String BOX_NO = "BOX_NO";

    public static final String POWER = "POWER";

    public static final String GRADE = "GRADE";

    public static final String SUBSTRATE_QUANTITY = "SUBSTRATE_QUANTITY";

    public static final String PACKAGING_TIME = "PACKAGING_TIME";

    public static final String PRINT_TIME = "PRINT_TIME";

    public static final String PRINT_STATUS = "PRINT_STATUS";

    public static final String COMPLETION_REPORTING_STATUS = "COMPLETION_REPORTING_STATUS";

    public static final String REMARK = "REMARK";

    public static final String VALID = "VALID";

    public static final String CREATOR_ID = "CREATOR_ID";

    public static final String CREATOR_NAME = "CREATOR_NAME";

    public static final String CREATE_TIME = "CREATE_TIME";

    public static final String UPDATER_ID = "UPDATER_ID";

    public static final String UPDATER_NAME = "UPDATER_NAME";

    public static final String UPDATE_TIME = "UPDATE_TIME";

    public static final String VERSION = "VERSION";

    public static final String LEAVE_LINE_TIME = "LEAVE_LINE_TIME";

    public static final String PORT_ID = "PORT_ID";

    public static final String PRINT_COUNT = "PRINT_COUNT";

    public static final String POWER_LEVEL = "POWER_LEVEL";

    public static final String CUSTOMER_ID = "CUSTOMER_ID";

    public static final String SAP_MATERIAL = "SAP_MATERIAL";

    public static final String LINE_BODY = "LINE_BODY";

    public static final String MODEL = "model";

    public static final String IS_ARRIVED = "is_arrived";

    public static final String ORDER_NUM = "ORDER_NUM";

}
