package com.cnbm.generator.code.entity;

import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDateTime;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * <p>
 * 包装箱基板关联表 ( 基板表 )
 * </p>
 *
 * @author codeGenerator
 * @since 2023-03-03
 */
@Data
@TableName("t_wo_packaging_box_substrate")
@ApiModel(value = "WoPackagingBoxSubstrate对象", description = "包装箱基板关联表 ( 基板表 )")
public class WoPackagingBoxSubstrate implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("ID")
    private Long id;

    @ApiModelProperty("包装箱ID，BoxId")
    private String packagingBoxId;

    @ApiModelProperty("基板ID")
    private String woSubstrateId;

    @ApiModelProperty("创建人")
    private Long creatorId;

    @ApiModelProperty("创建人姓名")
    private String creatorName;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private Long updaterId;

    @ApiModelProperty("更新人姓名")
    private String updaterName;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty("版本号")
    private Integer version;

    @ApiModelProperty("箱中位置")
    private Integer slot;

    @ApiModelProperty("进入时间")
    private LocalDateTime inputTime;

    @ApiModelProperty("删除标志，是否有效:1 可用 0不可用")
    @TableLogic
    private Integer valid;

    @ApiModelProperty("SAP MATERIAL,从t_wo_power_level 对应过来的")
    private String sapMaterial;

    @ApiModelProperty("线体,从t_wo_power_level 对应过来的，1=F ; 2=S")
    private Integer lineBody;

    @ApiModelProperty("功率等级")
    private String powerLevel;

    private LocalDateTime lastUpdateTime;

    @ApiModelProperty("补偿后的功率，pmpp")
    private Float pmpp;

    @ApiModelProperty("订单名")
    private String orderName;

    private Long binclassFl1;

    private Long binclassFl2;

    private Float etaFl1;

    private Float etaFl2;

    private Float ffFl1;

    private Float ffFl2;

    private Float imppFl1;

    private Float imppFl2;

    private Float insolflashcontrolFl1;

    private Float insolflashcontrolFl2;

    private Float insolmppFl1;

    private Float insolmppFl2;

    private Float insolvocFl1;

    private Float insolvocFl2;

    private Float insolFl1;

    private Float insolFl2;

    private Float iscFl1;

    private Float iscFl2;

    private LocalDateTime measTimeFl1;

    private LocalDateTime measTimeFl2;

    private Float pmppFl1;

    private Float pmppFl2;

    private Float tcellFl1;

    private Float tcellFl2;

    private Float tmonicellFl1;

    private Float tmonicellFl2;

    private Float umppFl1;

    private Float umppFl2;

    private Float uocFl1;

    private Float uocFl2;

    @ApiModelProperty("真实PMPP")
    private Float actualPmpp;


    public static final String ID = "ID";

    public static final String PACKAGING_BOX_ID = "PACKAGING_BOX_ID";

    public static final String WO_SUBSTRATE_ID = "WO_SUBSTRATE_ID";

    public static final String CREATOR_ID = "CREATOR_ID";

    public static final String CREATOR_NAME = "CREATOR_NAME";

    public static final String CREATE_TIME = "CREATE_TIME";

    public static final String UPDATER_ID = "UPDATER_ID";

    public static final String UPDATER_NAME = "UPDATER_NAME";

    public static final String UPDATE_TIME = "UPDATE_TIME";

    public static final String VERSION = "VERSION";

    public static final String SLOT = "SLOT";

    public static final String INPUT_TIME = "INPUT_TIME";

    public static final String VALID = "VALID";

    public static final String SAP_MATERIAL = "SAP_MATERIAL";

    public static final String LINE_BODY = "LINE_BODY";

    public static final String POWER_LEVEL = "POWER_LEVEL";

    public static final String LAST_UPDATE_TIME = "LAST_UPDATE_TIME";

    public static final String PMPP = "PMPP";

    public static final String ORDER_NAME = "ORDER_NAME";

    public static final String BINCLASS_FL1 = "BINCLASS_FL1";

    public static final String BINCLASS_FL2 = "BINCLASS_FL2";

    public static final String ETA_FL1 = "ETA_FL1";

    public static final String ETA_FL2 = "ETA_FL2";

    public static final String FF_FL1 = "FF_FL1";

    public static final String FF_FL2 = "FF_FL2";

    public static final String IMPP_FL1 = "IMPP_FL1";

    public static final String IMPP_FL2 = "IMPP_FL2";

    public static final String INSOLFLASHCONTROL_FL1 = "InsolFlashControl_FL1";

    public static final String INSOLFLASHCONTROL_FL2 = "InsolFlashControl_FL2";

    public static final String INSOLMPP_FL1 = "InsolMPP_FL1";

    public static final String INSOLMPP_FL2 = "InsolMPP_FL2";

    public static final String INSOLVOC_FL1 = "InsolVoc_FL1";

    public static final String INSOLVOC_FL2 = "InsolVoc_FL2";

    public static final String INSOL_FL1 = "Insol_FL1";

    public static final String INSOL_FL2 = "Insol_FL2";

    public static final String ISC_FL1 = "ISC_FL1";

    public static final String ISC_FL2 = "ISC_FL2";

    public static final String MEAS_TIME_FL1 = "MEAS_TIME_FL1";

    public static final String MEAS_TIME_FL2 = "MEAS_TIME_FL2";

    public static final String PMPP_FL1 = "PMPP_FL1";

    public static final String PMPP_FL2 = "PMPP_FL2";

    public static final String TCELL_FL1 = "Tcell_FL1";

    public static final String TCELL_FL2 = "Tcell_FL2";

    public static final String TMONICELL_FL1 = "Tmonicell_FL1";

    public static final String TMONICELL_FL2 = "Tmonicell_FL2";

    public static final String UMPP_FL1 = "UMPP_FL1";

    public static final String UMPP_FL2 = "UMPP_FL2";

    public static final String UOC_FL1 = "UOC_FL1";

    public static final String UOC_FL2 = "UOC_FL2";

    public static final String ACTUAL_PMPP = "ACTUAL_PMPP";

}
