package com.cnbm.dispatchDDJ.enums.ddj.ddj1;

import com.cnbm.s7.s7connector.api.DaveArea;
import com.cnbm.s7.s7connector.type.PlcVar;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2023/2/21 19:35
 */
public enum DDJPlc2WcsVar {

    Operate_Mode("Operate_Mode", PlcVar.INT,1, DaveArea.DB,2,0,0),
    Mission_State("Mission_State",PlcVar.INT,1,DaveArea.DB,2,2,0),
    From_Row("From_Row",PlcVar.INT,1,DaveArea.DB,2,4,0),
    From_List("From_List",PlcVar.INT,1,DaveArea.DB,2,6,0),
    From_Layer("From_Layer",PlcVar.INT,1,DaveArea.DB,2,8,0),
    To_Row("To_Row",PlcVar.INT,1,DaveArea.DB,2,10,0),
    To_List("To_List",PlcVar.INT,1,DaveArea.DB,2,12,0),
    To_Layer("To_Layer",PlcVar.INT,1,DaveArea.DB,2,14,0),
    Mission_Type("Mission_Type",PlcVar.INT,1,DaveArea.DB,2,16,0),
    Act_Pos_X("Act_Pos_X", PlcVar.DINT,1, DaveArea.DB,2,18,0),
    Act_Pos_Y("Act_Pos_Y", PlcVar.DINT,1, DaveArea.DB,2,22,0),
    Act_Speed_X("Act_Speed_X", PlcVar.DINT,1, DaveArea.DB,2,26,0),
    Act_Speed_Y("Act_Speed_Y", PlcVar.DINT,1, DaveArea.DB,2,30,0),
    Status_bit1("Status_bit1", PlcVar.BOOL_Array,8, DaveArea.DB,2,34,0),
    Status_bit2("Status_bit2", PlcVar.BOOL_Array,8, DaveArea.DB,2,35,0),
    Fault_No("Fault_No", PlcVar.INT,1, DaveArea.DB,2,36,0),
    Now_List("Now_List", PlcVar.INT,1, DaveArea.DB,2,38,0),
    Now_Layer("Now_Layer", PlcVar.INT,1, DaveArea.DB,2,40,0),
    Mission_ID("Act_Pos_X", PlcVar.INT,1, DaveArea.DB,2,42,0),
    Pallet_Num("Pallet_Num", PlcVar.STRING,1, DaveArea.DB,2,44,0),






    ;

    private String name;
    private DaveArea area;
    private Integer areaNumber;
    private Integer byteOffset;
    private Integer bitOffset;
    private PlcVar type;
    //length = 1代表 非数组;;;       length > 1 代表数组  ;; 注意 length这个参数 是实际plc中 数组的长度，和read操作相关
    //如果是String 类型不用填length 只需要填string类型的起始位置就行了，我会自己去取数据长度（也就是说这里的length并不是string 的长度）。
    private Integer length;

    //这个字段只是给 字符串变量 和 字符串数组 用, 这个字段是plc中设置的最大String长度
    private Integer strSize;

    DDJPlc2WcsVar(String name, PlcVar type, Integer length, DaveArea area, Integer areaNumber, Integer byteOffset, Integer bitOffset){
        this.name = name;
        this.type = type;
        this.length = length;
        this.area = area;
        this.areaNumber = areaNumber;
        this.byteOffset = byteOffset;
        this.bitOffset = bitOffset;
        this.strSize = 0;
    }
    DDJPlc2WcsVar(String name, PlcVar type, Integer length, DaveArea area, Integer areaNumber, Integer byteOffset, Integer bitOffset, Integer strSize){
        this.name = name;
        this.type = type;
        this.length = length;
        this.area = area;
        this.areaNumber = areaNumber;
        this.byteOffset = byteOffset;
        this.bitOffset = bitOffset;
        this.strSize = strSize;
    }

    public Integer getStrSize() {
        return strSize;
    }

    public void setStrSize(Integer strSize) {
        this.strSize = strSize;
    }

    public String getName() {
        return name;
    }

    public DaveArea getArea() {
        return area;
    }

    public Integer getAreaNumber() {
        return areaNumber;
    }

    public Integer getBitOffset() {
        return bitOffset;
    }

    public Integer getByteOffset() {
        return byteOffset;
    }

    public PlcVar getType() {
        return type;
    }

    public Integer getLength() {
        return length;
    }
}
