package com.cnbm.packing.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;


/**
 * 基板补偿功率 表
 *
 * @author codeGenerator
 * @since  2023-02-20
 */
@Data
@ApiModel(value = "基板补偿功率 表DTO对象")
public class WoCompensationPowerDTO implements Serializable {
    private static final long serialVersionUID = 1L;



	@ApiModelProperty(value = "ID")
	private Long id;

	@ApiModelProperty(value = "实际功率下限,（现场人员手动录入），如果实际功率不在范围，那么实际功率就是补偿功率")
	private Float actlPmppLow;

	@ApiModelProperty(value = "实际功率上限,（现场人员手动录入），如果实际功率不在范围，那么实际功率就是补偿功率")
	private Float actlPmppHigh;

	@ApiModelProperty(value = "计算公式")
	private String formula;

	@ApiModelProperty(value = "线体，1=F ; 2=S (用于过程1比对，和包装打印)（设备传给我们的）")
	private Integer lineBody;

	@ApiModelProperty(value = "系数a,（手动录入）")
	private Float coefficientA;

	@ApiModelProperty(value = "系数b,（手动录入）")
	private Float coefficientB;

	@ApiModelProperty(value = "备注")
	private String remark;

	@ApiModelProperty(value = "删除标志，是否有效:1 可用 0不可用")
	private Integer valid;

	@ApiModelProperty(value = "创建人")
	private Long creatorId;

	@ApiModelProperty(value = "创建人姓名")
	private String creatorName;

	@ApiModelProperty(value = "创建时间")
	private LocalDateTime createTime;

	@ApiModelProperty(value = "更新人")
	private Long updaterId;

	@ApiModelProperty(value = "更新人姓名")
	private String updaterName;

	@ApiModelProperty(value = "更新时间")
	private LocalDateTime updateTime;

	@ApiModelProperty(value = "版本号")
	private Integer version;

}