package com.cnbm.packing.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;


/**
 * 包装箱打印历史表
 *
 * @author codeGenerator
 * @since  2023-02-15
 */
@Data
@ApiModel(value = "包装箱打印历史表DTO对象")
public class WoPackagingPrintHistoryDTO implements Serializable {
    private static final long serialVersionUID = 1L;



	@ApiModelProperty(value = "ID")
	private Long id;

	@ApiModelProperty(value = "包装箱编号，关联t_wo_packaging_box.box_no")
	private String boxNo;

	@ApiModelProperty(value = "打印时间")
	private LocalDateTime printTime;

	@ApiModelProperty(value = "报工时间")
	private LocalDateTime completionReportingTime;

	@ApiModelProperty(value = "打印状态：0、未打印，1、已打印")
	private Integer printStatus;

	@ApiModelProperty(value = "报工状态：0、未报工，1、已报工, 指的是向ERP报工")
	private Integer completionReportingStatus;

	@ApiModelProperty(value = "移箱时间，指的是 箱子离开产线时间")
	private LocalDateTime leaveLineTime;

	@ApiModelProperty(value = "下片端口id")
	private String portId;

	@ApiModelProperty(value = "打印次数")
	private Integer printCount;

	@ApiModelProperty(value = "删除标志，是否有效:1 可用 0不可用")
	private Integer valid;

	@ApiModelProperty(value = "创建人")
	private Long creatorId;

	@ApiModelProperty(value = "创建人姓名")
	private String creatorName;

	@ApiModelProperty(value = "创建时间")
	private LocalDateTime createTime;

	@ApiModelProperty(value = "更新人")
	private Long updaterId;

	@ApiModelProperty(value = "更新人姓名")
	private String updaterName;

	@ApiModelProperty(value = "更新时间")
	private LocalDateTime updateTime;

	@ApiModelProperty(value = "版本号")
	private Integer version;

	@ApiModelProperty(value = "备注")
	private String remark;

}