package com.cnbm.packing.entity;

import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDateTime;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * <p>
 * 包装箱拆合箱历史表
 * </p>
 *
 * @author codeGenerator
 * @since 2023-02-16
 */
@Data
@TableName("t_change_packaging_box_history")
@ApiModel(value = "ChangePackagingBoxHistory对象", description = "包装箱拆合箱历史表")
public class ChangePackagingBoxHistory implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("ID")
    private Long id;

    @ApiModelProperty("基板ID或模组id")
    private String substrateId;

    @ApiModelProperty("源包装箱box no, 关联t_wo_packaging_box.box_no 字段")
    private String sourceBoxNo;

    @ApiModelProperty("源箱slot")
    private Integer sourceSlot;

    @ApiModelProperty("离开时间")
    private LocalDateTime leaveTime;

    @ApiModelProperty("目标箱box no, 关联t_wo_packaging_box.box_no 字段")
    private String targetBoxNo;

    @ApiModelProperty("目标箱slot")
    private Integer targetSlot;

    @ApiModelProperty("进入时间")
    private LocalDateTime inputTime;

    @ApiModelProperty("等级")
    private String grade;

    @ApiModelProperty("类型，1=加入包装箱；2=移除包装箱；3=换箱")
    private Integer type;

    @ApiModelProperty("删除标志，是否有效:1 可用 0不可用")
    @TableLogic
    private Integer valid;

    @ApiModelProperty("创建人")
    private Long creatorId;

    @ApiModelProperty("创建人姓名")
    private String creatorName;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private Long updaterId;

    @ApiModelProperty("更新人姓名")
    private String updaterName;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty("版本号")
    private Integer version;


    public static final String ID = "ID";

    public static final String SUBSTRATE_ID = "SUBSTRATE_ID";

    public static final String SOURCE_BOX_NO = "SOURCE_BOX_NO";

    public static final String SOURCE_SLOT = "SOURCE_SLOT";

    public static final String LEAVE_TIME = "LEAVE_TIME";

    public static final String TARGET_BOX_NO = "TARGET_BOX_NO";

    public static final String TARGET_SLOT = "TARGET_SLOT";

    public static final String INPUT_TIME = "INPUT_TIME";

    public static final String GRADE = "GRADE";

    public static final String TYPE = "TYPE";

    public static final String VALID = "VALID";

    public static final String CREATOR_ID = "CREATOR_ID";

    public static final String CREATOR_NAME = "CREATOR_NAME";

    public static final String CREATE_TIME = "CREATE_TIME";

    public static final String UPDATER_ID = "UPDATER_ID";

    public static final String UPDATER_NAME = "UPDATER_NAME";

    public static final String UPDATE_TIME = "UPDATE_TIME";

    public static final String VERSION = "VERSION";

}
