package com.cnbm.packing.entity;

import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDateTime;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * <p>
 * 打印标签模板表
 * </p>
 *
 * @author codeGenerator
 * @since 2023-02-20
 */
@Data
@TableName("t_print_model")
@ApiModel(value = "PrintModel对象", description = "打印标签模板表")
public class PrintModel implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("id")
    private Long id;

    @ApiModelProperty("编码")
    private String code;

    @ApiModelProperty("班组名称")
    private String name;

    @ApiModelProperty("启用状态:0 、停用，1、启用")
    private Integer enabled;

    @ApiModelProperty("创建人")
    private Long creatorId;

    @ApiModelProperty("创建人姓名")
    private String creatorName;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private Long updaterId;

    @ApiModelProperty("更新人姓名")
    private String updaterName;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty("版本号")
    private Integer version;

    @ApiModelProperty("删除标志，是否有效:1 可用 0不可用")
    @TableLogic
    private Integer valid;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("类型，0：模组标签，1：等级标签")
    private Integer type;

    @ApiModelProperty("是否默认模板，0：否，1：是")
    private Integer isDefault;

    @ApiModelProperty("是否要预览，0：否，1：是")
    private Integer isPreview;

    @ApiModelProperty("模板内容")
    private String content;

    @ApiModelProperty("线体，1=F ; 2=S (用于过程1比对，和包装打印)（设备传给我们的）")
    private Integer lineBody;

    @ApiModelProperty("是否启用，0 停用；1 启用")
    private Integer isEnable;


    public static final String ID = "ID";

    public static final String CODE = "CODE";

    public static final String NAME = "NAME";

    public static final String ENABLED = "ENABLED";

    public static final String CREATOR_ID = "CREATOR_ID";

    public static final String CREATOR_NAME = "CREATOR_NAME";

    public static final String CREATE_TIME = "CREATE_TIME";

    public static final String UPDATER_ID = "UPDATER_ID";

    public static final String UPDATER_NAME = "UPDATER_NAME";

    public static final String UPDATE_TIME = "UPDATE_TIME";

    public static final String VERSION = "VERSION";

    public static final String VALID = "VALID";

    public static final String REMARK = "REMARK";

    public static final String TYPE = "TYPE";

    public static final String IS_DEFAULT = "IS_DEFAULT";

    public static final String IS_PREVIEW = "IS_PREVIEW";

    public static final String CONTENT = "CONTENT";

    public static final String LINE_BODY = "line_body";

    public static final String IS_ENABLE = "is_enable";

}
