package com.cnbm.packing.entity;

import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 基板补偿功率 表
 * </p>
 *
 * @author codeGenerator
 * @since 2023-02-20
 */
@Data
@TableName("t_wo_compensation_power")
@ApiModel(value = "WoCompensationPower对象", description = "基板补偿功率 表")
public class WoCompensationPower implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("ID")
    private Long id;

    @ApiModelProperty("实际功率下限,（现场人员手动录入），如果实际功率不在范围，那么实际功率就是补偿功率")
    private Float actlPmppLow;

    @ApiModelProperty("实际功率上限,（现场人员手动录入），如果实际功率不在范围，那么实际功率就是补偿功率")
    private Float actlPmppHigh;

    @ApiModelProperty("计算公式")
    private String formula;

    @ApiModelProperty("线体，1=F ; 2=S (用于过程1比对，和包装打印)（设备传给我们的）")
    private Integer lineBody;

    @ApiModelProperty("系数a,（手动录入）")
    private Float coefficientA;

    @ApiModelProperty("系数b,（手动录入）")
    private Float coefficientB;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("删除标志，是否有效:1 可用 0不可用")
    @TableLogic
    private Integer valid;

    @ApiModelProperty("创建人")
    private Long creatorId;

    @ApiModelProperty("创建人姓名")
    private String creatorName;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private Long updaterId;

    @ApiModelProperty("更新人姓名")
    private String updaterName;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty("版本号")
    private Integer version;


    public static final String ID = "id";

    public static final String ACTL_PMPP_LOW = "actl_pmpp_low";

    public static final String ACTL_PMPP_HIGH = "actl_pmpp_high";

    public static final String FORMULA = "formula";

    public static final String LINE_BODY = "line_body";

    public static final String COEFFICIENT_A = "coefficient_a";

    public static final String COEFFICIENT_B = "coefficient_b";

    public static final String REMARK = "remark";

    public static final String VALID = "valid";

    public static final String CREATOR_ID = "creator_id";

    public static final String CREATOR_NAME = "creator_name";

    public static final String CREATE_TIME = "create_time";

    public static final String UPDATER_ID = "updater_id";

    public static final String UPDATER_NAME = "updater_name";

    public static final String UPDATE_TIME = "update_time";

    public static final String VERSION = "version";

}
