package com.cnbm.packing.entity;

import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 包装箱打印历史表
 * </p>
 *
 * @author codeGenerator
 * @since 2023-02-15
 */
@Data
@TableName("t_wo_packaging_print_history")
@ApiModel(value = "WoPackagingPrintHistory对象", description = "包装箱打印历史表")
public class WoPackagingPrintHistory implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("ID")
    private Long id;

    @ApiModelProperty("包装箱编号，关联t_wo_packaging_box.box_no")
    private String boxNo;

    @ApiModelProperty("打印时间")
    private LocalDateTime printTime;

    @ApiModelProperty("报工时间")
    private LocalDateTime completionReportingTime;

    @ApiModelProperty("打印状态：0、未打印，1、已打印")
    private Integer printStatus;

    @ApiModelProperty("报工状态：0、未报工，1、已报工, 指的是向ERP报工")
    private Integer completionReportingStatus;

    @ApiModelProperty("移箱时间，指的是 箱子离开产线时间")
    private LocalDateTime leaveLineTime;

    @ApiModelProperty("下片端口id")
    private String portId;

    @ApiModelProperty("打印次数")
    private Integer printCount;

    @ApiModelProperty("删除标志，是否有效:1 可用 0不可用")
    @TableLogic
    private Integer valid;

    @ApiModelProperty("创建人")
    private Long creatorId;

    @ApiModelProperty("创建人姓名")
    private String creatorName;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private Long updaterId;

    @ApiModelProperty("更新人姓名")
    private String updaterName;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty("版本号")
    private Integer version;

    @ApiModelProperty("备注")
    private String remark;


    public static final String ID = "ID";

    public static final String BOX_NO = "BOX_NO";

    public static final String PRINT_TIME = "PRINT_TIME";

    public static final String COMPLETION_REPORTING_TIME = "COMPLETION_REPORTING_TIME";

    public static final String PRINT_STATUS = "PRINT_STATUS";

    public static final String COMPLETION_REPORTING_STATUS = "COMPLETION_REPORTING_STATUS";

    public static final String LEAVE_LINE_TIME = "LEAVE_LINE_TIME";

    public static final String PORT_ID = "PORT_ID";

    public static final String PRINT_COUNT = "PRINT_COUNT";

    public static final String VALID = "VALID";

    public static final String CREATOR_ID = "CREATOR_ID";

    public static final String CREATOR_NAME = "CREATOR_NAME";

    public static final String CREATE_TIME = "CREATE_TIME";

    public static final String UPDATER_ID = "UPDATER_ID";

    public static final String UPDATER_NAME = "UPDATER_NAME";

    public static final String UPDATE_TIME = "UPDATE_TIME";

    public static final String VERSION = "VERSION";

    public static final String REMARK = "REMARK";

}
