package com.cnbm.packing.entity;

import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * <p>
 * 功率等级 表
 * </p>
 *
 * @author codeGenerator
 * @since 2023-02-20
 */
@Data
@TableName("t_wo_power_level")
@ApiModel(value = "WoPowerLevel对象", description = "功率等级 表")
public class WoPowerLevel implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("ID")
    private Long id;

    @ApiModelProperty("功率等级名称，（现场人员手动录入）")
    private String powerClass;

    @ApiModelProperty("pmpp_low,（现场人员手动录入）")
    private Float pmppLow;

    @ApiModelProperty("pmpp_high,（现场人员手动录入）")
    private Float pmppHigh;

    @ApiModelProperty("物料号,（现场人员手动录入）")
    private String sapMaterialNum;

    @ApiModelProperty("线体，1=F ; 2=S (用于过程1比对，和包装打印)（设备传给我们的）")
    private Integer lineBody;

    @ApiModelProperty("lable_voc,（手动录入）")
    private BigDecimal lableVoc;

    @ApiModelProperty("lable_isc,（手动录入）")
    private BigDecimal lableIsc;

    @ApiModelProperty("lable_vmpp,（手动录入）")
    private BigDecimal lableVmpp;

    @ApiModelProperty("lable_impp,（手动录入）")
    private BigDecimal lableImpp;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("删除标志，是否有效:1 可用 0不可用")
    @TableLogic
    private Integer valid;

    @ApiModelProperty("创建人")
    private Long creatorId;

    @ApiModelProperty("创建人姓名")
    private String creatorName;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private Long updaterId;

    @ApiModelProperty("更新人姓名")
    private String updaterName;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty("版本号")
    private Integer version;


    public static final String ID = "id";

    public static final String POWER_CLASS = "power_class";

    public static final String PMPP_LOW = "pmpp_low";

    public static final String PMPP_HIGH = "pmpp_high";

    public static final String SAP_MATERIAL_NUM = "sap_material_num";

    public static final String LINE_BODY = "line_body";

    public static final String LABLE_VOC = "lable_voc";

    public static final String LABLE_ISC = "lable_isc";

    public static final String LABLE_VMPP = "lable_vmpp";

    public static final String LABLE_IMPP = "lable_impp";

    public static final String REMARK = "remark";

    public static final String VALID = "valid";

    public static final String CREATOR_ID = "creator_id";

    public static final String CREATOR_NAME = "creator_name";

    public static final String CREATE_TIME = "create_time";

    public static final String UPDATER_ID = "updater_id";

    public static final String UPDATER_NAME = "updater_name";

    public static final String UPDATE_TIME = "update_time";

    public static final String VERSION = "version";

}
