package com.cnbm.packing.mapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.cnbm.packing.dto.PowerReportDTO;
import com.cnbm.packing.dto.WoPackagingBoxSubstrateDTO;
import com.cnbm.packing.param.PackingInfoQueryParam;
import com.cnbm.packing.param.PowerReportQueryParam;
import com.cnbm.packing.param.SubIdQueryParam;
import com.cnbm.packing.vo.SubIdPageVo;
import org.apache.ibatis.annotations.Param;

import com.cnbm.common.dao.BaseDao;
import com.cnbm.packing.entity.WoPackagingBoxSubstrate;
import org.apache.ibatis.annotations.Mapper;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * 包装箱基板关联表
 *
 * @author codeGenerator
 * @since 2023-02-16
 */
@Mapper
public interface WoPackagingBoxSubstrateMapper extends BaseDao<WoPackagingBoxSubstrate> {
    WoPackagingBoxSubstrate getOneByWoSubstrateId(@Param("woSubstrateId") String woSubstrateId);


    int updatePackagingBoxIdAndSlotByWoSubstrateId(@Param("packagingBoxId") String packagingBoxId, @Param("slot") Integer slot, @Param("woSubstrateId") String woSubstrateId);

    List<PowerReportDTO> powerReport(@Param("queryParam") PowerReportQueryParam queryParam);
    List<String> orderNameList();

    List<WoPackagingBoxSubstrateDTO> substrateList(Map<String, Object> params);
    //List<WoPackagingBoxSubstrateDTO> substrateList(@Param("woSubstrateId") String woSubstrateId);
    IPage<WoPackagingBoxSubstrateDTO> substratePage(Page<?> page, @Param("param")PackingInfoQueryParam param);

    IPage<SubIdPageVo> subIdPage(Page<?> page, @Param("param") SubIdQueryParam param);
}
