package com.cnbm.packing.service;

import com.cnbm.dynamic.datasource.annotation.DataSource;
import com.cnbm.packing.dto.CamlineExtendArgDTO;
import com.cnbm.packing.dto.CamlineSubIdDTO;
import com.cnbm.packing.dto.CamlineSubIdForImportDTO;
import com.cnbm.packing.dto.WoPowerLevelDTO;
import com.cnbm.packing.mapper.CamlineMapper;

import io.swagger.models.auth.In;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2023/2/15 14:19
 */
@Service
public class DynamicDataSourceService {
    @Autowired
    CamlineMapper mapper;
    @Autowired
    WoPowerLevelServiceBiz powerLevelServiceBiz;


    public Integer getTodayBoxNum(){
        return mapper.getTodayBoxNum();
    }

    @DataSource("camline")
    @Transactional
    public float getPMPPBySubId(String subId){
        return mapper.getPMPPBySubId(subId);
    }

    @DataSource("camline")
    @Transactional
    public String getOrderNameBySubId(String subId){
        return mapper.getOrderNameBySubId(subId);
    }

    @DataSource("camline")
    @Transactional
    public CamlineSubIdDTO getSubIdByCamline(String subId){
        return mapper.getSubIdByCamline(subId);
    }

    @DataSource("camline")
    @Transactional
    public CamlineExtendArgDTO getExtendArgFromCamline(String subId){
        return mapper.getExtendArgFromCamline(subId);
    }

    @DataSource("camline")
    @Transactional
    public List<CamlineSubIdForImportDTO> getAlllCamlineSubForImp(String[] subIds){
        return mapper.getSubIdByCamlineForImpoet(subIds);
    }

}
