package com.cnbm.packing.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.cnbm.admin.utils.BaseSupportUtils;
import com.cnbm.common.page.PageData;
import com.cnbm.common.service.impl.CrudServiceImpl;
import com.cnbm.common.utils.ConvertUtils;
import com.cnbm.packing.dto.ChangePackagingBoxHistoryDTO;
import com.cnbm.packing.entity.ChangePackagingBoxHistory;
import com.cnbm.packing.mapper.ChangePackagingBoxHistoryMapper;
import com.cnbm.packing.service.ChangePackagingBoxHistoryServiceBiz;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 包装箱拆合箱历史表
 *
 * @author codeGenerator
 * @since 2023-02-16
 */
@Service
public class ChangePackagingBoxHistoryServiceBizImpl extends CrudServiceImpl<ChangePackagingBoxHistoryMapper, ChangePackagingBoxHistory, ChangePackagingBoxHistoryDTO> implements ChangePackagingBoxHistoryServiceBiz {

    @Autowired
    private ChangePackagingBoxHistoryMapper mapper;

    @Override
    public QueryWrapper<ChangePackagingBoxHistory> getWrapper(Map<String, Object> params){

        QueryWrapper<ChangePackagingBoxHistory> wrapper = new QueryWrapper<>();

        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        if(params.get("startTime")!=null && params.get("endTime")!=null){
            LocalDateTime startTime = LocalDateTime.parse(params.get("startTime").toString(),df);
            LocalDateTime endTime = LocalDateTime.parse(params.get("endTime").toString(),df);
            wrapper.between(startTime!=null && endTime!=null,ChangePackagingBoxHistory.CREATE_TIME, startTime, endTime);
        }
        if(params.get("type")!=null) {
            Integer type = Integer.parseInt( params.get("type").toString());
            wrapper.eq(ObjectUtils.isNotNull(type), ChangePackagingBoxHistory.TYPE, type);
        }
        if(params.get("startTime")==null && params.get("endTime")==null && params.get("type")==null){
            wrapper.apply(true, "TO_DAYS(NOW())-TO_DAYS(create_time) = 0");
        }
        wrapper.orderByDesc(ChangePackagingBoxHistory.CREATE_TIME);

        return wrapper;
    }

    @Override
    public PageData<ChangePackagingBoxHistoryDTO> page (Map<String, Object> params){
        IPage<ChangePackagingBoxHistory> page = baseDao.selectPage(
            getPage(params, ChangePackagingBoxHistory.CREATE_TIME, false),
            getWrapper(params)
        );
        return getPageData(page, ChangePackagingBoxHistoryDTO.class);
    }

    @Override
    public ChangePackagingBoxHistoryDTO get(Long id) {
        ChangePackagingBoxHistory entity = baseDao.selectById(id);
        return ConvertUtils.sourceToTarget(entity, ChangePackagingBoxHistoryDTO.class);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void save(ChangePackagingBoxHistoryDTO dto) {
        ChangePackagingBoxHistory entity = ConvertUtils.sourceToTarget(dto, ChangePackagingBoxHistory.class);
        BaseSupportUtils.setCommonField(entity);
        insert(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void update(ChangePackagingBoxHistoryDTO dto) {
        ChangePackagingBoxHistory entity = ConvertUtils.sourceToTarget(dto, ChangePackagingBoxHistory.class);
        BaseSupportUtils.setUpdateCommonField(entity);
        updateById(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void delete(Long[] ids) {
        //删除
        deleteBatchIds(Arrays.asList(ids));
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<ChangePackagingBoxHistoryDTO> list(Map<String, Object> params) {
        List<ChangePackagingBoxHistoryDTO> list = mapper.list(params);
        return list;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<ChangePackagingBoxHistory> historyList(Map<String, Object> params) {
        QueryWrapper<ChangePackagingBoxHistory> wrapper = getWrapper(params);
        List<ChangePackagingBoxHistory> historyList = mapper.selectList(wrapper);
        return historyList;
    }

}