package com.cnbm.packing.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.cnbm.admin.utils.BaseSupportUtils;
import com.cnbm.common.page.PageData;
import com.cnbm.common.service.impl.CrudServiceImpl;
import com.cnbm.common.utils.ConvertUtils;
import com.cnbm.packing.dto.CompensationPowerXSDTO;
import com.cnbm.packing.dto.WoCompensationPowerDTO;
import com.cnbm.packing.entity.WoCompensationPower;
import com.cnbm.packing.mapper.WoCompensationPowerMapper;
import com.cnbm.packing.param.CompensationQueryParam;
import com.cnbm.packing.service.WoCompensationPowerServiceBiz;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 基板补偿功率 表
 *
 * @author codeGenerator
 * @since 2023-02-20
 */
@Service
public class WoCompensationPowerServiceBizImpl extends CrudServiceImpl<WoCompensationPowerMapper, WoCompensationPower, WoCompensationPowerDTO> implements WoCompensationPowerServiceBiz {

    @Autowired
    private WoCompensationPowerMapper mapper;
    
    @Override
    public QueryWrapper<WoCompensationPower> getWrapper(Map<String, Object> params){

        QueryWrapper<WoCompensationPower> wrapper = new QueryWrapper<>();
        if(params.get("lineBody")!=null) {
            Integer lineBody = Integer.parseInt(params.get("lineBody").toString());
            wrapper.eq(ObjectUtils.isNotNull(lineBody), WoCompensationPower.LINE_BODY, lineBody);
        }

        return wrapper;
    }

    @Override
    public PageData<WoCompensationPowerDTO> page (Map<String, Object> params){
        IPage<WoCompensationPower> page = baseDao.selectPage(
                getPage(params, WoCompensationPower.CREATE_TIME, false),
                getWrapper(params)
        );
        return getPageData(page, WoCompensationPowerDTO.class);
    }

    @Override
    public WoCompensationPowerDTO get(Long id) {
        WoCompensationPower entity = baseDao.selectById(id);
        return ConvertUtils.sourceToTarget(entity, WoCompensationPowerDTO.class);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void save(WoCompensationPowerDTO dto) {
        WoCompensationPower entity = ConvertUtils.sourceToTarget(dto, WoCompensationPower.class);
        BaseSupportUtils.setCommonField(entity);
        insert(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void update(WoCompensationPowerDTO dto) {
        WoCompensationPower entity = ConvertUtils.sourceToTarget(dto, WoCompensationPower.class);
        BaseSupportUtils.setUpdateCommonField(entity);
        updateById(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void delete(Long[] ids) {
        //删除
        deleteBatchIds(Arrays.asList(ids));
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<WoCompensationPowerDTO> list() {
        List<WoCompensationPowerDTO> list = mapper.list();
        return list;
    }

    @Override
    public float calculCompensationPMPP(float pmpp, Integer lineBody) {
        CompensationQueryParam compensationQueryParam = new CompensationQueryParam();
        compensationQueryParam.setPmpp(pmpp);
        compensationQueryParam.setLineBody(lineBody);


        CompensationPowerXSDTO conffBySubIdAndLineBody = mapper.getConffBySubIdAndLineBody(compensationQueryParam);
        if(conffBySubIdAndLineBody!=null){
            return pmpp*conffBySubIdAndLineBody.getA()+conffBySubIdAndLineBody.getB();
        }else {
            return pmpp;
        }
    }


    public WoCompensationPowerMapper getMapper() {
        return mapper;
    }
}