package com.cnbm.packing.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.cnbm.admin.utils.BaseSupportUtils;
import com.cnbm.common.page.PageData;
import com.cnbm.common.service.impl.CrudServiceImpl;
import com.cnbm.common.utils.ConvertUtils;
import com.cnbm.packing.dto.WoPowerLevelDTO;
import com.cnbm.packing.entity.WoPowerLevel;
import com.cnbm.packing.mapper.WoPowerLevelMapper;
import com.cnbm.packing.param.CompensationQueryParam;
import com.cnbm.packing.service.WoPowerLevelServiceBiz;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 功率等级 表
 *
 * @author codeGenerator
 * @since 2023-02-15
 */
@Service
public class WoPowerLevelServiceBizImpl extends CrudServiceImpl<WoPowerLevelMapper, WoPowerLevel, WoPowerLevelDTO> implements WoPowerLevelServiceBiz {

    @Autowired
    private WoPowerLevelMapper mapper;

    @Override
    public QueryWrapper<WoPowerLevel> getWrapper(Map<String, Object> params){

        QueryWrapper<WoPowerLevel> wrapper = new QueryWrapper<>();
        if(params.get("lineBody")!=null) {
            Integer lineBody = Integer.parseInt(params.get("lineBody").toString());
            wrapper.eq(ObjectUtils.isNotNull(lineBody), WoPowerLevel.LINE_BODY, lineBody);
        }


        return wrapper;
    }

    @Override
    public PageData<WoPowerLevelDTO> page (Map<String, Object> params){
        IPage<WoPowerLevel> page = baseDao.selectPage(
                getPage(params, WoPowerLevel.CREATE_TIME, false),
                getWrapper(params)
        );
        return getPageData(page, WoPowerLevelDTO.class);
    }

    @Override
    public WoPowerLevelDTO get(Long id) {
        WoPowerLevel entity = baseDao.selectById(id);
        return ConvertUtils.sourceToTarget(entity, WoPowerLevelDTO.class);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void save(WoPowerLevelDTO dto) {
        WoPowerLevel entity = ConvertUtils.sourceToTarget(dto, WoPowerLevel.class);
        BaseSupportUtils.setCommonField(entity);
        insert(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void update(WoPowerLevelDTO dto) {
        WoPowerLevel entity = ConvertUtils.sourceToTarget(dto, WoPowerLevel.class);
        BaseSupportUtils.setUpdateCommonField(entity);
        updateById(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void delete(Long[] ids) {
        //删除
        deleteBatchIds(Arrays.asList(ids));
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<WoPowerLevelDTO> list() {
        List<WoPowerLevelDTO> list = mapper.list();
        return list;
    }

    @Override
    public WoPowerLevel getArgByPMPP(float pmpp, Integer lineBody) {
        CompensationQueryParam compensationQueryParam = new CompensationQueryParam();
        compensationQueryParam.setLineBody(lineBody);
        compensationQueryParam.setPmpp(pmpp);
        return mapper.getPowerLevelByLineBodyAndPMPP(compensationQueryParam);
    }
}