package com.cnbm.s7.retrydemo;


import com.cnbm.s7.s7connector.exception.S7CheckResultException;
import com.cnbm.s7.s7connector.impl.S7BaseConnection;
import com.cnbm.s7.s7connector.impl.nodave.Nodave;
import org.apache.commons.lang3.RandomUtils;
import org.springframework.remoting.RemoteAccessException;

import java.io.IOException;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.util.Arrays;

/**
 * @Author: cx
 * @Description:
 */
public class RetryDemoTask {

    public static void main(String[] args) {
        PipedInputStream pipedInputStream=new PipedInputStream();
        PipedOutputStream pipedOutputStream=new PipedOutputStream();
        try {
            pipedInputStream.connect(pipedOutputStream);
            //默认一次最多只能写入1024字节
            byte[] data=new byte[1000];
            byte[] store=new byte[20];
            Arrays.fill(data, (byte)1);
            System.out.println("first writing data");
            //每次写1000字节数据
            pipedOutputStream.write(data,0,data.length);
            System.out.println("finish first writing");
            int count=1;
            while(count<100){
                System.out.println(count+" times read data");
                pipedInputStream.read(store, 0, store.length); //每次读20字节数据
                System.out.println(count+" times finish reading data");
                System.out.println((count+1)+" times write data");
                pipedOutputStream.write(data);//每次写1000字节数据
                System.out.println((count+1)+" times finish writing data");
                count++;
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 重试方法
     * @return
     */
    public synchronized static boolean retryTask(String param)  {
        System.out.println("retry-task : 收到请求参数:"+param);

        int i = RandomUtils.nextInt(0,11);
        System.out.println("retry-task : 随机生成的数:"+i);
        if (i == 0) {
            System.out.println("retry-task : 为0,抛出参数异常.");
            //因为Illeague这个异常我们没有在exceptionMap里面配置，所以 抛出这个异常后
            //spring-retry不会进行重试，而是会直接进入recovery函数
            throw new IllegalArgumentException("retry-task : 参数异常");
        }else if (i  == 1){
            System.out.println("retry-task : 为1,返回true.");
            return true;
        }else if (i == 2){
            System.out.println("retry-task : 为2,返回false.");
            return false;
        }else{
            //因为RemoteAccessExcep这个异常我们在exceptionMap里面配置了，所以 抛出这个异常后
            //spring-retry会进行重试
            System.out.println("retry-task : 大于2,抛出自定义异常.");
            throw new RemoteAccessException("retry-task : 大于2,抛出远程访问异常");
        }
    }
    public static void checkResults(final int libnodaveResult) {
        if (libnodaveResult != Nodave.RESULT_OK) {
            final String msg = Nodave.strerror(libnodaveResult);
//			throw new IllegalArgumentException("Result: " + msg);
            throw new S7CheckResultException("errMsg : "+msg);
        }
    }

    public synchronized static boolean retryTask2(String param)  {
        System.out.println("retry-task : 收到请求参数:"+param+"  hashCode:"+Thread.currentThread().hashCode());

        int i = 1;
        System.out.println("retry-task : 随机生成的数:"+i+"  hashCode:"+Thread.currentThread().hashCode());
        checkResults(i);
        Integer a =1;
        a=a+1;
        return true;
    }
}
