/*
Copyright 2016 S7connector members (github.com/s7connector)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
package com.cnbm.s7.s7connector.api;

import com.cnbm.s7.s7connector.type.PlcVar;
import com.cnbm.s7.s7connector.type.TransportSize;

import java.io.Closeable;

public interface S7Connector extends Closeable {
	/**
	 * Reads an area
	 * desc : 只要未抛出异常，都是 操作成功的 ( 锁 )
	 * @param area
	 * @param areaNumber
	 * @param bytes
	 * @param offset
	 * @return
	 */
	public byte[] read(DaveArea area, int areaNumber, int bytes, int offset);

	/**
	 * Reads an area  读需要bit 位置的 变量（其实就是 read bool变量的时候调用这个方法。）
	 * desc : 只要未抛出异常，都是 操作成功的 ( 锁 )
	 * @param area
	 * @param areaNumber
	 * @param bytes
	 * @param offset
	 * @return
	 */
	public byte[] read(DaveArea area, int areaNumber, int bytes, int offset, int bitOffset, TransportSize transportSize);
	/**
	 * Writes an area
	 * desc : 只要未抛出异常，都是 操作成功的 ( 锁 )
	 * @param area
	 * @param areaNumber
	 * @param offset
	 * @param buffer
	 */
	public void write(DaveArea area, int areaNumber, int offset, byte[] buffer);

	//如果 bitOffset 没有  那么就填0 ( 锁 )
	public void write(DaveArea area, int areaNumber, int byteOffset, int bitOffset, byte[] buffer, PlcVar var);

}
